=== src/CMakeLists.txt ===

# Now we can configure the build of both libraries
add_subdirectory(XpertMass)
add_subdirectory(XpertMassGui)

# And finally, we wan export the targets
# The header files for the libraries are installed in the
# corresponding directory's list file.


# Install and export static targets
install(TARGETS Core_static Gui_static
        EXPORT XpertMassStaticTargets
				LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# Export static targets
install(EXPORT XpertMassStaticTargets
        FILE XpertMassStaticTargets.cmake
        NAMESPACE XpertMass::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/XpertMass)

export(EXPORT XpertMassStaticTargets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/XpertMassStaticTargets.cmake"
       NAMESPACE XpertMass::)

# Install and export shared targets
install(TARGETS Core Gui
        EXPORT XpertMassSharedTargets
				LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
				RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# Export shared targets
install(EXPORT XpertMassSharedTargets
        FILE XpertMassSharedTargets.cmake
        NAMESPACE XpertMass::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/XpertMass)

export(EXPORT XpertMassSharedTargets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/XpertMassSharedTargets.cmake"
       NAMESPACE XpertMass::)

# Generate and install config files
include(CMakePackageConfigHelpers)

if(UNIX)
  configure_package_config_file(${CMAKE_UTILS_PATH}/XpertMassConfig.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/XpertMassConfig.cmake"
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/XpertMass)

  write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/XpertMassConfigVersion.cmake"
    VERSION "${CMAKE_PROJECT_VERSION_MAJOR}.${CMAKE_PROJECT_VERSION_MINOR}"
    COMPATIBILITY SameMinorVersion)

  install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/XpertMassConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/XpertMassConfigVersion.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/XpertMass)
endif()
