=== debian/changelog ===
libxpertmass (1.1.0-1) unstable; urgency=medium

  * Upstream release with build system improvements.

  * Fix bug due to trying to find file up of the source directory
    (thanks to 	Adrian Bunk <bunk@debian.org>, Closes: #1077251).

 -- Filippo Rusconi <lopippo@debian.org>  Sun, 28 Jul 2024 19:27:58 +0200

libxpertmass (1.0.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1076552).

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 17 Jul 2024 22:45:46 +0200
