=== debian/control ===
Source: libxpertmass
Section: libs
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dh-exec,
 d-shlibs,
 qt6-base-dev,
 libqt6core5compat6-dev,
 libqt6svg6-dev,
 qt6-documentation-tools,
 qt6-base-doc-html,
 libisospec++-dev (>=2.2.1),
 libpappsomspp-dev (>= 0.9.38),
 catch2
Standards-Version: 4.7.0
Homepage: http://www.msxpertsuite.org/libxpertmass/
Vcs-Browser: https://salsa.debian.org/debichem-team/libxpertmass
Vcs-Git: https://salsa.debian.org/debichem-team/libxpertmass.git

Package: libxpertmass-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libxpertmass1 (= ${binary:Version}),
 ${misc:Depends}
Recommends: libxpertmass-doc
Description: C++ mass spectrometry libraries (non-GUI development files)
 The libXpertMass and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * msXpertSuite/massXpert2;
  * msXpertSuite/mineXpert2.
 .
 libXpertMass contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and mineXpert2.
 .
 This package ships the development files for the libXpertMass library.


Package: libxpertmass1
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: C++ mass spectrometry libraries (non-GUI runtime files)
 The libXpertMass and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * msXpertSuite/massXpert2;
  * msXpertSuite/mineXpert2.
 .
 libXpertMass contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and mineXpert2.
 .
 This package ships the runtime files for the libXpertMass library.

Package: libxpertmassgui-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libxpertmass-dev (= ${binary:Version}),
 libxpertmassgui1 (= ${binary:Version}),
 ${misc:Depends}
Recommends: libxpertmass-doc
Description: C++ mass spectrometry libraries (GUI development files)
 The libXpertMass and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * msXpertSuite/massXpert2;
  * msXpertSuite/mineXpert2.
 .
 libXpertMass contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and mineXpert2.
 .
 This package ships the development files for the libXpertMassGui library.

Package: libxpertmassgui1
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: C++ mass spectrometry libraries (GUI runtime files)
 The libXpertMass and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * msXpertSuite/massXpert2;
  * msXpertSuite/mineXpert2.
 .
 libXpertMass contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and mineXpert2.
 .
 This package ships the runtime files for the libXpertMassGui library.

Package: libxpertmass-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends}
Description: C++ mass spectrometry libraries (documentation files)
 The libXpertMass and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * msXpertSuite/massXpert2;
  * msXpertSuite/mineXpert2.
 .
 libXpertMass contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and mineXpert2.
 .
 This package ships the developer documentation for the two libraries.
